node{
    def sonarOrgKey = "cours-eftl-ggestin"
    def sonarProjectKey = "${sonarOrgKey}_rc-petclinic"

    try{

   

        stage('Checkout'){
            checkout scm
            def pom = readMavenPom file: 'pom.xml'
            if (pom){
                echo "Building version ${pom.version}"
            }
            sh "chmod +x ./mvnw"
        }

        stage("build") {
        sh "./mvnw package -DskipTests"
        }
        
        stage("quality analysis"){
            def skipTests = ''
            if ( env.SKIP_TEST.toBoolean() ) {
                skipTests = '-DskipTests'
            }
        sh "./mvnw verify ${skipTests} org.sonarsource.scanner.maven:sonar-maven-plugin:3.9.0.2155:sonar -Dsonar.projectKey=${sonarProjectKey}"
        }

        stage("archive artefacts") {
            archiveArtifacts '**/target/*.jar'
            if ( !(env.SKIP_TEST.toBoolean()) ){
                junit allowEmptyResults: true, skipPublishingChecks: true, testResults: '**/target/surefire-reports/*.xml'
            }
        }
        
     } catch (Exception error) {
         //Send mail, notification
         throw error
    }
}
